<template>
  <div>
    <GI18nCard
      :i18n="i18n"
      :card="card"
      :level="level"
      v-bind="$attrs"
      :wiki-entry="wikiEntry"
      @deleteElement="$emit('delete')"
    >
      <template v-if="value.location && card" #card-title-append>
        <v-spacer />
        <GDropDownMenu
          i18n="form.addElement"
          :available-elements="availableElements()"
          icon="add"
          :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
          @addElement="addElement"
        />
      </template>
      <v-row dense>
        <GCol cols="12">
          <div :class="card ? 'mt-4' : ''">
            <DccLocalizedTextBlock
              v-model="value.name"
              i18n="dcc.common.contactType.name"
              validate="required"
              :disabled="disabled"
            />
          </div>
        </GCol>
        <GCol cols="12">
          <XmlTextField
            v-model="value.eMail"
            i18n="dcc.common.contactType.email"
            :disabled="disabled"
            validate="notEmptyStringType"
          />
        </GCol>
        <GCol cols="12" md="6">
          <XmlTextField
            v-model="value.phone"
            i18n="dcc.common.contactType.phone"
            :disabled="disabled"
            validate="notEmptyStringType"
          />
        </GCol>
        <GCol cols="12" md="6">
          <XmlTextField
            v-model="value.fax"
            i18n="dcc.common.contactType.fax"
            :disabled="disabled"
            validate="notEmptyStringType"
          />
        </GCol>
        <GCol v-if="notStrict" cols="12">
          <GCheckbox
            v-model="hasLocationCheckboxState"
            i18n="dcc.common.contactType.hasLocation"
            @change="hasLocationCheckboxChange"
          />
        </GCol>
      </v-row>
      <Location
        v-if="hasLocationCheckboxState && value.location"
        ref="location"
        v-model="value.location"
        :disabled="disabled"
        :card="locationCard"
        i18n="dcc.common.locationType.title"
        v-bind="$attrs"
        @deleteFurther="updateUI"
      />
    </GI18nCard>
  </div>
</template>

<script>
import { LocationType, RichContentType } from "@d-ptb/dcc-js";
import GI18nCard from "../../App/Common/GI18nCard";
import DccLocalizedTextBlock from "../../App/Form/XML/DccLocalizedTextBlock";
import XmlTextField from "../../App/Form/XML/XmlTextField";
import GCheckbox from "../../App/Form/gCheckbox";
import Location from "./Location";
import GCol from "~/components/App/Common/GCol";
import { insertIf } from "~/assets/util/general";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";

export default {
  name: "Contact",
  components: {
    GDropDownMenu,
    GCol,
    Location,
    GCheckbox,
    XmlTextField,
    DccLocalizedTextBlock,
    GI18nCard,
  },
  props: {
    value: Object,
    card: {
      type: Boolean,
      default: true,
    },
    locationCard: {
      type: Boolean,
      default: false,
    },
    i18n: String,
    stacked: Boolean,
    disabled: Boolean,
    notStrict: Boolean,
    level: String,
    wikiEntry: {
      type: String,
      default: "contact",
    },
  },
  data() {
    return {
      hasLocationCheckboxState: !!this.value.location,
      lastLocation: null,
    };
  },
  watch: {
    value(val) {
      // update hasLocationCheckboxState when value is updated
      this.hasLocationCheckboxState = !!val.location;
    },
  },
  methods: {
    updateUI() {
      this.$nextTick(() => {
        this.$forceUpdate();
      });
    },
    availableElements() {
      return ["further"]
        .filter((x) => !this.blacklist().includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.locationType.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(
          this.value.location.further && this.value.location.further[0],
          "further"
        ),
      ];
    },
    hasLocationCheckboxChange(val) {
      if (val) {
        this.value.location = this.lastLocation || new LocationType();
      } else {
        this.lastLocation = this.value.location;
        this.$delete(this.value, "location");
      }
    },
    addElement(element) {
      switch (element) {
        case "further":
          this.$set(this.value.location, "further", [new RichContentType()]);
          this.$nextTick(() => this.$forceUpdate());
      }
    },
  },
};
</script>
